#ifndef _OME_CORE_H
//! \cond
#define _OME_CORE_H "$Id: OMEcore.h 348 2020-05-21 04:14:03Z geoff $"
//! \endcond

/** \defgroup OMEcore OME Core Functions
 * @{
 */

#ifndef OME_CORE_CALL
//#define OME_CORE_CALL OME_FAST_CALL
#define OME_CORE_CALL /* */
#endif
OME_CORE_CALL int allow(class OMEthread *thread, OMEtype &result,
	const OMEtype &methodName);
OME_CORE_CALL int alwaysAllow(class OMEthread *thread, OMEtype &result,
	const OMEtype &methodName);
OME_CORE_CALL int highBit(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int lowBit(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int mergeBits(class OMEthread *thread, OMEtype &result,
	const OMEtype &src, const OMEtype &srcOffset, const OMEtype &srcLen,
	const OMEtype &orig, const OMEtype &destOffset);
OME_CORE_CALL int concatBits(class OMEthread *thread, OMEtype &result,
	const OMEtype &bitData, const OMEtype &bitsToAdd,
	const OMEtype &currentState);
OME_CORE_CALL int SHA1hash(class OMEthread *thread, OMEtype &result,
	const OMEtype &message);
OME_CORE_CALL int MD5hash(class OMEthread *thread, OMEtype &result,
	const OMEtype &message);
OME_CORE_CALL int makePublicKeyPair(class OMEthread *thread, OMEtype &result,
	const OMEtype &secret);
OME_CORE_CALL int makeSessionKey(class OMEthread *thread, OMEtype &result,
	const OMEtype &publicKey, const OMEtype &randomData);
OME_CORE_CALL int decryptSessionKey(class OMEthread *thread, OMEtype &result,
	const OMEtype &privateKey, const OMEtype &encryptedKey);
OME_CORE_CALL int initializeCipher(class OMEthread *thread, OMEtype &result,
	const OMEtype &secret, const OMEtype &dir, const OMEtype &initVec);
OME_CORE_CALL int freeCipher(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int encryptMessage(class OMEthread *thread, OMEtype &result,
	const OMEtype &cipherData, const OMEtype &message);
OME_CORE_CALL int decryptMessage(class OMEthread *thread, OMEtype &result,
	const OMEtype &cipherData, const OMEtype &message);
OME_CORE_CALL int getRandomInteger(class OMEthread *thread, OMEtype &result,
	const OMEtype &upperBound);
OME_CORE_CALL int makeRandomKey(class OMEthread *thread, OMEtype &result,
	const OMEtype &desiredBits);
OME_CORE_CALL int getLocalizedData(class OMEthread *thread, OMEtype &result,
	const OMEtype &fileName, const OMEtype &attrName);
OME_CORE_CALL int getHostKey(class OMEthread *thread, OMEtype &result,
	const OMEtype &secret, const OMEtype &logicalDomain);
OME_CORE_CALL int getRemoteHostKey(class OMEthread *thread, OMEtype &result,
	const OMEtype &rmtHostName, const OMEtype &logicalDomain);
OME_CORE_CALL int display(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int debugDisplay(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int displayAsHex(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int debugDisplayAsHex(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int makeAsString(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int makeAsHexString(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int hexToBinary(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int makeUnique(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int displayVisible(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int calculateStringLength(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int setDebugMask(class OMEthread *thread, OMEtype &result,
	const OMEtype &mask);
OME_CORE_CALL int listEncodingVersions(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int encodeData(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &version);
OME_CORE_CALL int decodeData(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int decodeFirstElement(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int compressString(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int uncompressString(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int gzipString(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int gunzipString(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int parseHTTPuriData(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &defaultScheme,
	const OMEtype &defaultAuthority, const OMEtype &defaultContext);
OME_CORE_CALL int parsePathComponents(class OMEthread *thread, OMEtype &result,
	const OMEtype &path);
OME_CORE_CALL int relativePathToAbsolute(class OMEthread *thread, OMEtype &result,
	const OMEtype &currentDir, const OMEtype &path);
OME_CORE_CALL int pathComponentsToString(class OMEthread *thread, OMEtype &result,
	const OMEtype &elements, const OMEtype &startIndex,
	const OMEtype &stopIndex);
OME_CORE_CALL int parseStringIntoSSIelements(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int expandSSIvars(class OMEthread *thread, OMEtype &result,
	const OMEtype &cmdElements, const OMEtype &env);
OME_CORE_CALL int stripHTML(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int sleepForSeconds(class OMEthread *thread, OMEtype &result,
	const OMEtype &t);
OME_CORE_CALL int openURL(class OMEthread *thread, OMEtype &result,
	const OMEtype &url);
OME_CORE_CALL int getIOhandle(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID);
OME_CORE_CALL int closeIO(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &flags, const OMEtype &sidesMask);
OME_CORE_CALL int readBytes(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &bytesToRead,
	const OMEtype &bufferSize);
OME_CORE_CALL int seekToOffset(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &offset);
OME_CORE_CALL int receiveDatagram(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &bufferSize);
OME_CORE_CALL int writeBytes(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &dataToSend);
OME_CORE_CALL int sendDatagram(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &dataToSend,
	const OMEtype &dest);
OME_CORE_CALL int writeVectorOfBytes(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &skipOffset,
	const OMEtype &dataToSend);
OME_CORE_CALL int selectForRead(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &permitPreempt);
OME_CORE_CALL int selectForWrite(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID, const OMEtype &permitPreempt);
OME_CORE_CALL int acceptConnection(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID);
OME_CORE_CALL int getLocalAddress(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID);
OME_CORE_CALL int getPeerAddress(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID);
OME_CORE_CALL int getErrorStatus(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID);
OME_CORE_CALL int getFileInfo(class OMEthread *thread, OMEtype &result,
	const OMEtype &ioID);
OME_CORE_CALL int unlinkFile(class OMEthread *thread, OMEtype &result,
	const OMEtype &fileName);
OME_CORE_CALL int removeDirectory(class OMEthread *thread, OMEtype &result,
	const OMEtype &fileName);
OME_CORE_CALL int renameFile(class OMEthread *thread, OMEtype &result,
	const OMEtype &orgFileName, const OMEtype &newFileName);
OME_CORE_CALL int makeDirectory(class OMEthread *thread, OMEtype &result,
	const OMEtype &dirName);
OME_CORE_CALL int listDirectory(class OMEthread *thread, OMEtype &result,
	const OMEtype &dirName);
OME_CORE_CALL int getSystemInfo(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int getSystemInfoAttribute(class OMEthread *thread, OMEtype &result,
	const OMEtype &attrName);
OME_CORE_CALL int convertLocalRelativeTimeToAbsolute(class OMEthread *thread, OMEtype &result,
	const OMEtype &timeArg, const OMEtype &asGMT);
OME_CORE_CALL int convertAbsoluteToLocalRelativeTime(class OMEthread *thread, OMEtype &result,
	const OMEtype &timeData);
OME_CORE_CALL int getLocalRelativeTime(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int getRelativeMilliseconds(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int rfc1123Date(class OMEthread *thread, OMEtype &result,
	const OMEtype &argData);
OME_CORE_CALL int iso8601Date(class OMEthread *thread, OMEtype &result,
	const OMEtype &argData);
OME_CORE_CALL int convertRFC1123date(class OMEthread *thread, OMEtype &result,
	const OMEtype &timeString);
OME_CORE_CALL int timeDifference(class OMEthread *thread, OMEtype &result,
	const OMEtype &time1, const OMEtype &time2);
OME_CORE_CALL int convertURIescapes(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int safeURI(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int parseHTTPformData(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &desiredType);
OME_CORE_CALL int parseAttributeValuePairs(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &desiredType,
	const OMEtype &whiteSpace, const OMEtype &equalsSign);
OME_CORE_CALL int parseMIMEheaderLines(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int asciiToBase64(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &breakIntoLines);
OME_CORE_CALL int base64ToASCII(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int parseMIMEblock(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int decodeMultiPart(class OMEthread *thread, OMEtype &result,
	const OMEtype &mimeTypeName, const OMEtype &data);
OME_CORE_CALL int decodeMIMEdata(class OMEthread *thread, OMEtype &result,
	const OMEtype &mimeTypeName, const OMEtype &data);
OME_CORE_CALL int OMEloadOIL2(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &justList);
OME_CORE_CALL int createACLthatAllowsOthers(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int createACLthatDisallowsOthers(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int makeDefaultACL(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int makePermitEveryoneACL(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int addUserToACL(class OMEthread *thread, OMEtype &result,
	const OMEtype &acl, const OMEtype &user,
	const OMEtype &methods);
OME_CORE_CALL int createNewOIDthatOnlyAllowsOthers(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int becomeUser(class OMEthread *thread, OMEtype &result,
	const OMEtype &userName, const OMEtype &password);
OME_CORE_CALL int becomePseudoUser(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int OMEshutdown(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int allocateXMLparser(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int freeXMLparser(class OMEthread *thread, OMEtype &result,
	const OMEtype &parserID);
OME_CORE_CALL int parseXMLusingParser(class OMEthread *thread, OMEtype &result,
	const OMEtype &parserID, const OMEtype &data,
	const OMEtype &doneFlag);
OME_CORE_CALL int parseXML(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int lookupAddress(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int dottedAddress(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int yieldSlice(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int oidIsExternal(class OMEthread *thread, OMEtype &result,
	const OMEtype &obj);
OME_CORE_CALL int registerService(class OMEthread *thread, OMEtype &result,
	const OMEtype &name, const OMEtype &obj, const OMEtype &flag);
OME_CORE_CALL int unregisterService(class OMEthread *thread, OMEtype &result,
	const OMEtype &name, const OMEtype &obj);
OME_CORE_CALL int lookupLocalService(class OMEthread *thread, OMEtype &result,
	const OMEtype &name);
OME_CORE_CALL int listRegisteredServices(class OMEthread *thread, OMEtype &result,
	const OMEtype &flag);
OME_CORE_CALL int inCalled(class OMEthread *thread, OMEtype &result);
OME_CORE_CALL int length(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int midstr(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &offset, const OMEtype &len);
OME_CORE_CALL int midchar(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &offset);
OME_CORE_CALL int charToString(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int reverseString(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int forceToASCII(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int typeOf(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int exactTypeOf(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int elementCount(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);
OME_CORE_CALL int findSubtring(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &substring);
OME_CORE_CALL int findSubtringAfter(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &substring, const OMEtype &offset);
OME_CORE_CALL int findLastSubtring(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &substring);
OME_CORE_CALL int findLastSubtringBefore(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &substring, const OMEtype &offset);
OME_CORE_CALL int tokenizeString(class OMEthread *thread, OMEtype &result,
	const OMEtype &source, const OMEtype &delimString,
	const OMEtype &convFlag);
OME_CORE_CALL int stringToNumber(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &desiredType);
OME_CORE_CALL int indexExists(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &subscript);
OME_CORE_CALL int nextIndex(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &subscript);
OME_CORE_CALL int priorIndex(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &subscript);
OME_CORE_CALL int getKeyForIndex(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &subscript);
OME_CORE_CALL int deleteIndex(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &subscript);
OME_CORE_CALL int mergeArrays(class OMEthread *thread, OMEtype &result,
	const OMEtype &args);
OME_CORE_CALL int encodeLengthAsString(class OMEthread *thread, OMEtype &result,
	const OMEtype &len);
OME_CORE_CALL int decodeStringAsLength(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int arrayToSet(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int setToArray(class OMEthread *thread, OMEtype &result,
	const OMEtype &data);
OME_CORE_CALL int getApplicationVariable(class OMEthread *thread, OMEtype &result,
	const OMEtype &varName, const OMEtype &extraVars);
OME_CORE_CALL int getEnvironmentVariable(class OMEthread *thread, OMEtype &result,
	const OMEtype &varName);
OME_CORE_CALL int substituteText(class OMEthread *thread, OMEtype &result,
	const OMEtype &data, const OMEtype &replacements);
OME_CORE_CALL int substituteEnvironmentVariables(class OMEthread *thread, OMEtype &result,
	const OMEtype &line, const OMEtype &extraVariables);
OME_CORE_CALL int orderSubscripts(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg, const OMEtype &mode);
OME_CORE_CALL int sortArray(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg, const OMEtype &mode);
OME_CORE_CALL int convertCase(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg, const OMEtype &toLower);
OME_CORE_CALL int compareStrings(class OMEthread *thread, OMEtype &result,
	const OMEtype &str1, const OMEtype &str2, const OMEtype &fuzzyCompare);
OME_CORE_CALL int createNLM(class OMEthread *thread, OMEtype &result,
	const OMEtype &catName, const OMEtype &messID,
	const OMEtype &defaultMess, const OMEtype &args,
	const OMEtype &extras);
OME_CORE_CALL int nlmInfo(class OMEthread *thread, OMEtype &result,
	const OMEtype &arg);

/** @}
 */
#endif
/* vim: set expandtab shiftwidth=4 tabstop=4: */
